<?php
/* Copyright (C) Youbility Software - All Rights Reserved
 * www.youbility.de
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

class Semknox_ProductSearch_Block_Admin_Button extends Mage_Adminhtml_Block_System_Config_Form_Field
{

    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        $this->setElement($element);

        $config = $element->getData()['field_config'];
        $helper = Mage::helper('semknoxps');

        $onclick = ((string) $config->onclick) ? (string) $config->onclick : 'configForm.submit()';
        $buttontext = ((string) $config->buttontext) ?  $this->__((string) $config->buttontext) : $this->__('Save Config');
        $value = ((string) $config->value) ?  $this->__((string) $config->value) : null;
        $name = ((string) $config->name) ?  $this->__((string) $config->name) : null;

        $html = $this->getLayout()->createBlock('adminhtml/widget_button')
                     ->setType('button')
                     ->setClass('scalable')
                     ->setValue($value)
                     ->setLabel($buttontext)
                     ->setOnClick($onclick)
                     ->toHtml();

        if($name)
        {
            $html = str_replace('<button ', '<button name="'.$name.'" ', $html);
        }

        $html = str_replace('<button ', '<button data-storeid="'.$helper->getCurrentStoreId().'"', $html);

        return $html;
    }
}