<?php
/* Copyright (C) Youbility Software - All Rights Reserved
 * www.youbility.de
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

class Semknox_ProductSearch_Block_CatalogSearch_Flags extends Mage_Core_Block_Text
{

    public function getSemknoxFlags()
    {
        /** @var Semknox_ProductSearch_Model_ProductResult  $apiRequest */
        $apiRequest = Mage::getSingleton('semknoxps/ProductResult');

        $products = $apiRequest->getProducts();
        $flags = array();

        foreach ($products as $product) {
            if(! isset($product['flags'])) {
                continue;
            }

            // to do: use show all flags not just the first
            $flags[$product['articleNumber']] = $product['flags'];
        }

        return $flags;
    }



    protected function _toHtml()
    {
        $flags = $this->getSemknoxFlags();

        if(! $flags) {
            return;
        }

        $flags  = json_encode($flags);

        $script = $this->_getJavascriptCode($flags);

        return '<script type="text/javascript">' . $script . '</script>';
    }




    protected function _getJavascriptCode($flags)
    {
        // remove whitespace from $boxHtml with preg_replace

        return '
(function($) {
    var productsFlags = '.$flags.';
    var box   = "<div class=\"rank\"><div class=\"corner\"></div><div class=\"value\"></div></div>";

    $.each(productsFlags, function(articleNumber, flags) {

        var $product = $("#product-collection-image-"+articleNumber).closest(".item");
        var $flagsBox = $("<div class=\"flags\"></div>");

        $.each(flags, function(idx, flag)
        {
            var $box = $(box);
            //console.log($box.html());
            $box.find(".value").html(flag.value);

            $flagsBox.prepend($box);
        });

        $product.prepend($flagsBox);

    });

})(jQuery);
';

    }

}