<?php
/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@magento.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade Magento to newer
 * versions in the future. If you wish to customize Magento for your
 * needs please refer to http://www.magento.com for more information.
 *
 * @category    Mage
 * @package     Mage_CatalogSearch
 * @copyright  Copyright (c) 2006-2015 X.commerce, Inc. (http://www.magento.com)
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

/**
 * Layered Navigation block for search
 *
 */
class Semknox_ProductSearch_Block_CatalogSearch_Layer_View extends Mage_Core_Block_Template//Mage_Catalog_Block_Layer_View
{

    protected $filters;


    /**
     * Get layer object
     *
     * @return Mage_Catalog_Model_Layer
     */
    public function getLayer()
    {
        $layer = Mage::getSingleton('semknoxps/catalogSearch_layer');
        return $layer;
    }


    protected function _prepareLayout()
    {
        /*
        $stateBlock = $this->getLayout()->createBlock('semknoxps/catalogSearch_layer_state')
                           ->setLayer($this->getLayer());
        $this->setChild('layer_state', $stateBlock);
        */

        $filters = $this->getFilterableAttributes();

        foreach($filters as $key => $filter)
        {

            $this->setChild($key.'_semknoxps_filter', $this->getLayout()->createBlock('semknoxps/catalogSearch_Layer_filter')->setData('filter', $filter));

        }

        $this->getLayer()->apply();

        return parent::_prepareLayout();

    }



    /**
     * Show Filters Block or not
     *
     * @return bool
     */
    public function canShowBlock()
    {
        $layer = $this->getLayer();

        if($layer->getFilters())
        {
            return true;
        }

        return false;
    }

    /**
     * Show Fiters
     *
     * @return bool
     */
    public function canShowOptions()
    {
        return $this->canShowBlock();
    }


    /**
     * get Attributes to create Filter Blocks out of them
     *
     * @return array
     */
    public function getFilterableAttributes()
    {
        $filters = $this->getLayer()->getFilters();

        return $filters;
    }

    /**
     * get Filter Blocks to ouput in view block
     *
     */
    public function getFilters()
    {
        if(!is_null($this->filters)) return $this->filters;

        $filters = $this->getLayer()->getFilters();

        foreach($filters as $key => $filter)
        {
            $filters[$key] = $this->getChild($key.'_semknoxps_filter');
        }

        $this->filters = $filters;

        return $filters;

    }

}
