<?php
/* Copyright (C) Youbility Software - All Rights Reserved
 * www.youbility.de
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

class Semknox_ProductSearch_Block_CatalogSearch_Product_List_Toolbar extends Mage_Catalog_Block_Product_List_Toolbar
{

    protected $_currentOrder = 'null'; // has to be a string

    public function getAvailableOrders()
    {
        /** @var Semknox_ProductSearch_Model_ProductResult  $productResult */
        $productResult = Mage::getSingleton('semknoxps/ProductResult');

        $availableOrders = (array) $productResult->getOrders();
        $orders = array();

        foreach($availableOrders as $order)
        {
            $value = (string) $order['id'];
            $label = $order['viewName'];

            $orders[$value] = $label;

            if(isset($order['set']))
            {
                $this->_currentOrder = $value;
            }

        }

        return $orders;
    }

    public function getCurrentOrder()
    {
        return $this->_currentOrder;
    }

    /**
     * Return current URL with rewrites and additional parameters
     *
     * @param array $params Query parameters
     * @return string
     */
    public function getPagerUrl($params=array())
    {

        /* @var Semknox_ProductSearch_Helper_Data $helper */
        $helper = Mage::helper('semknoxps');

        if($helper->semknoxpsIsActive() && $helper->semknoxSeoUrlIsActive())
        {
            $url = $helper->getLastDirectoryInUrl();

            $urlParams = array();
            $urlParams['_current']  = true;
            $urlParams['_escape']   = true;
            $urlParams['_use_rewrite']   = true;
            $urlParams['_query']    = $params;

            return $this->getUrl($url, $urlParams);

        } else {
            return parent::getPagerUrl($params);
        }

    }

    protected function _toHtml()
    {
        /* @var Semknox_ProductSearch_Helper_Data $helper */
        $helper = Mage::helper('semknoxps');


        if($helper->showAvailableOrdersToolbarByMagento())
        {
            return parent::_toHtml();
        }

        return '<style>.sort-by { display:none }</style>'.parent::_toHtml();

    }

}
