<?php
/* Copyright (C) Youbility Software - All Rights Reserved
 * www.youbility.de
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

class Semknox_ProductSearch_Block_SearchMiniForm extends Mage_Core_Block_Text
{

    protected function _toHtml()
    {
        /**
         * @var Semknox_ProductSearch_Helper_Data $helper
         * @var Semknox_ProductSearch_Model_ProductManager $productManager
         */
        $helper = Mage::helper('semknoxps');
        if(!$helper->semknoxpsIsActive()) return '';

        $js = '';
        $css = '';

        $productManager = Mage::getModel('semknoxps/productManager');
        $ajaxSearchUrl = explode('?',$productManager->getSearchUrl());

        $js .= 'var sxCurrentQuery = '.json_encode(Mage::app()->getRequest()->getParams()).';';
        $js .= 'var sxSearchRequest = { url : "'. $ajaxSearchUrl[0].'", body : "'. $helper->semknoxRequestUrlShortener($ajaxSearchUrl[1]).'&query=" };';
        $js .= 'var searchQuery = "'. Mage::helper('catalogsearch')->getEscapedQueryText() .'";';
        $js .= 'var sxInfiniteScroll = '. $helper->semknoxInfiniteScrollActive() .';';
        $js .= 'var sxContentSearch = '. $helper->semknoxShowSiteSearch360Results(true) .';';
        $js .= 'var sxInfiniteScrollShowButton = '. $helper->semknoxShowInfiniteScrollButton() .';';
        $js .= 'var sxListingImageWidth = '. $helper->getProductListingImageWith() .';';
        $js .= 'var sxListingImageHeight = '. $helper->getProductListingImageHeight() .';';

        $js .= 'var urls = {};';
        $js .= 'urls.compareProductUrl = "'. Mage::getUrl('semknoxps/ajax/compareUrl').'";';
        $js .= 'urls.wishlistProductUrl = "'. Mage::getUrl('semknoxps/ajax/wishlistUrl') .'";';
        $js .= 'urls.addToCartUrl = "'. Mage::getUrl('semknoxps/ajax/addToCartUrl') .'";';
        $js .= 'urls.nativeSearchUrl = "'. Mage::getUrl('semknoxps') .'?q=";';
        $js .= 'urls.sxModulUrl = "'. Mage::getUrl('semknoxps') .'";';
        $js .= 'urls.magentoBaseUrl = "'. Mage::getUrl('').'";';

        return '<script id="sxSearchVars" type="text/javascript">'.$js.'</script>'.$this->_getCssCode();
    }

    protected function _getCssCode()
    {
        /* @var Semknox_ProductSearch_Helper_Data $helper */
        $helper = Mage::helper('semknoxps');

        $style['.item .rank, .sxRANGE .noUi-connect']['background-color'] = $helper->semknoxPrimaryColor();
        $style['.sx-query, .sx-highlight']['color'] = $helper->semknoxSecondaryColor();

        $css = array();

        foreach($style as $selector => $data)
        {
            foreach($data as $key => $value)
            {
                if(strlen($value) == 6)
                {
                    $css[] = $selector.'{
                        '.$key.': #'.$value.' !important;
                        }

                    ';
                }
            }
        }

        return (count($css)) ? '<style>'.implode($css).'</style>' : '';
    }

}