<?php
/* Copyright (C) Youbility Software - All Rights Reserved
 * www.youbility.de
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

class Semknox_ProductSearch_Helper_CatalogSearch_Data extends Mage_CatalogSearch_Helper_Data
{

    /**
     * Retrieve result page url and set "secure" param to avoid confirm
     * message when we submit form from secure page to unsecure
     *
     * @param   string $query
     * @return  string
     */
    public function getResultUrl($query = null)
    {
        /* @var Semknox_ProductSearch_Helper_Data $helper */
        $helper = Mage::helper('semknoxps');

        if(!$helper->semknoxpsIsActive()) return parent::getResultUrl($query);

        if($helper->semknoxSeoUrlIsActive())
        {

            return Mage::app()->getStore()->getBaseUrl();

        }
        else
        {
            return $this->_getUrl($helper->getResultsUrl(), array(
                '_query' => array(self::QUERY_VAR_NAME => $query),
                '_secure' => $this->_getApp()->getFrontController()->getRequest()->isSecure()
            ));
        }

    }


    public function getEscapedQueryText()
    {
        /* @var Semknox_ProductSearch_Helper_Data $helper */
        $helper = Mage::helper('semknoxps');
        $action = Mage::app()->getRequest()->getActionName();
        $pageIdentifier = Mage::app()->getFrontController()->getAction()->getFullActionName();

        if(!$helper->semknoxpsIsActive()) return parent::getEscapedQueryText();

        if($helper->semknoxSeoUrlIsActive() && $action != 'noRoute' && $pageIdentifier != 'semknoxps_index_index')
        {
            // empty query string, because the URL-slug is the query string now
            return '';
        } else {
            return parent::getEscapedQueryText();
        }

    }


}
