<?php
/* Copyright (C) Youbility Software - All Rights Reserved
 * www.youbility.de
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 */

class Semknox_ProductSearch_Adminhtml_Semknox_ProductSearch_UploadController extends Mage_Core_Controller_Front_Action
{

    public function startAction()
    {
        $storeId = Mage::app()->getRequest()->getParam('storeid');
        $startedBy = Mage::app()->getRequest()->getParam('startedby');

        $pause = Mage::app()->getRequest()->getParam('pause');

        $model = Mage::getModel('semknoxps/InitialUpload', array($storeId, $startedBy, $pause));

        try {

            $progressInfo = $model->start();

            $percentage = $progressInfo['percentage'];
            $message = $progressInfo['message'];

            $return =  array(
                'collectCompleted' => $progressInfo['collectCompleted'],
                //'status'    => ($percentage == 100) ? 'ok' : 'working',
                'status'    => $progressInfo['status'],
                'percentage'=> $percentage,
                'message'   => $message
            );

            $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
            $this->getResponse()->setBody(json_encode($return));
        }
        catch(RuntimeException $e) {
            $this->getResponse()->clearHeaders()
                 ->setHeader('Content-type','application/json',true)
                 ->setHeader('HTTP/1.0','400',true);

            $error = array(
                'status' => $e->getMessage(),
                'percentage' => 0,
                'collectCompleted' => $progressInfo['collectCompleted'],
                'message' => $e->getMessage()
            );
            $this->getResponse()->setBody(json_encode($error));
        }
    }

    public function wizardsetstepAction()
    {
        $storeId = Mage::app()->getRequest()->getParam('storeid');
        $wizardStep = Mage::app()->getRequest()->getParam('step');

        /**
         * @var Semknox_ProductSearch_Helper_Data $helper
         */
        $helper = Mage::helper('semknoxps');
        $helper->setCurrentWizardStep($wizardStep, $storeId);

    }


    public function checkAction()
    {
        $storeId = Mage::app()->getRequest()->getParam('storeid');
        $startedby = Mage::app()->getRequest()->getParam('startedby');


        //check if cronjob is running
        $cronModel = Mage::getModel('semknoxps/InitialUpload', array($storeId, 'cron'));
        $cronStatus = $cronModel->check(true);

        if($cronStatus['percentage'] > 0 || $startedby == 'cron'){

            $cronStatus['runningTime'] = time() - $cronStatus['startTime'];
            $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
            $this->getResponse()->setBody(json_encode($cronStatus));
            return;
        }

        // if cron not running, go on
        $model = Mage::getModel('semknoxps/InitialUpload', array($storeId));
        $status = $model->check(true);

        $status['started'] = ($status['percentage'] == 0) ? false : true;

        $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
        $this->getResponse()->setBody(json_encode($status));

    }

    public function cancelAction()
    {
        $storeId = Mage::app()->getRequest()->getParam('storeid');

        $model = Mage::getModel('semknoxps/InitialUpload', array($storeId, 'cron'));
        $status['canceled'] = $model->cancel();

        $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
        $this->getResponse()->setBody(json_encode($status));

    }



}