<?php

require_once(Mage::getModuleDir('controllers','Mage_Cms').DS.'IndexController.php');

class Semknox_ProductSearch_Cms_IndexController extends Mage_Cms_IndexController
{


    /**
     * Render CMS 404 Not found page with Status Code 200
     *
     * @param string $coreRoute
     */
    public function noRouteAction($coreRoute = null)
    {

        /* @var Semknox_ProductSearch_Helper_Data $helper */
        $helper = Mage::helper('semknoxps');

        if($helper->semknoxpsIsActive() && $helper->semknoxSeoUrlIsActive())
        {
            $this->getResponse()->setHeader('HTTP/1.1','200');
            $this->getResponse()->setHeader('Status','200');

            $pageId = Mage::getStoreConfig(Mage_Cms_Helper_Page::XML_PATH_NO_ROUTE_PAGE);
            if (!Mage::helper('cms/page')->renderPage($this, $pageId)) {
                $this->_forward('defaultNoRoute');
            }

        } else {

            parent::noRouteAction($coreRoute);

        }

    }


    /**
     * Default no route page action
     * Used if no route page don't configure or available
     *
     */
    public function defaultNoRouteAction()
    {
        /* @var Semknox_ProductSearch_Helper_Data $helper */
        $helper = Mage::helper('semknoxps');

        if($helper->semknoxpsIsActive() && $helper->semknoxSeoUrlIsActive())
        {
            $this->getResponse()->setHeader('HTTP/1.1','200');
            $this->getResponse()->setHeader('Status','200');

            $this->loadLayout();
            $this->renderLayout();

        } else {

            parent::defaultNoRouteAction();
        }
    }


}
