jQuery(document).ready(function($) {

    $.ajaxSetup({ cache: false });

    // check, if search is ready
    if(typeof sxCurrentQuery == 'undefined') return;

    var changeViewModeTo = false;

    /*
     urls.compareProductUrl set in SearchMiniForm.php
     urls.wishlistProductUrl set in SearchMiniForm.php
     urls.nativeSearchUrl set in SearchMiniForm.php
     */

    var $sxSearchForm = $('input[name=q]:visible').closest('form'); // form#search_mini_form

    var selectors = window.sxSelectors;
    var orderSelectItemHtml =  window.sxOrderSelectItemHtml;
    var orderSelectItemValueAttribute =  window.sxOrderSelectItemValueAttribute;

    /*
     window.sxOffset; set in ajaxSearchConfig.js
     window.sxLimit; set in ajaxSearchConfig.js
     */
    if(typeof window.sxLimit == 'undefined' ) window.sxLimit = 108;
    if(typeof window.sxOffset == 'undefined' ) window.sxOffset = 0;

    var defaultSelectors = {
        productsGrid             :'.products-grid',
        productsList             :'.products-list',
        contentList              :'.content-list',

        filtersList              :'#narrow-by-list',
        pager                    :'.pager',
        searchInput              :'input[name=q]',
        orderSelect              :'div.sort-by select',
        orderSelectItem          :'option',
        sortSwitcher             :'a.sort-by-switcher, div.sort-by a[href*="dir=desc"], div.sort-by a[href*="dir=asc"]',
        viewMode                 :'p.view-mode a',
        viewModeActive           :'p.view-mode strong',

        sxExplanation            :'font#sxExplanation',
        sxSearchString           :'font#sxSearchString',
        sxOrderToolbar           :'font#sxOrderToolbar',
        sxProductBoxgridTemplate :'#sxAjaxProductBox',
        sxProductBoxlistTemplate :'#sxAjaxProductBoxList',
        sxContentListTemplate    :'#sxAjaxContentList',

        sxFilterItemTemplate     :'#sxAjaxFilterItem',
        sxOrderToolbarTemplate   :'#sxAjaxOrderToolbar'
    };

    for(var selectorName in defaultSelectors) {
        if(! selectors[selectorName]) {
            selectors[selectorName] = defaultSelectors[selectorName];
        }
    }

    var contentSearchTabsQty = $(selectors.contentList).length;

    if(!orderSelectItemHtml){

        orderSelectItemHtml = '<%orderSelectItem value="%viewName" data-sxvalue="%id"  data-sxkey="order">%viewName</%orderSelectItem>';
    }

    if(!orderSelectItemValueAttribute)
    {
        orderSelectItemValueAttribute = 'value';
    }

    function getSearchQuery()
    {
        return $sxSearchForm.find(selectors.searchInput).val();
    }

    $sxSearchForm.on('submit', function( event )
    {
        if($(selectors.productsGrid).length > 0 || $(selectors.productsList).length > 0) {
            event.preventDefault();

            sxCurrentQuery = {};

            searchQuery = getSearchQuery();

            if(searchQuery.length == 0) {
                console.log('search string empty');
                return; // do not send empty requests
            } 

            // reset offset
            window.sxOffset = 0;

            $.sxStartSearch();
        }
    });


    $(document).on('click', '.sxAjaxCompareUrl, .sxAjaxWishlistUrl, .sxAjaxToCartUrl, .sxAjaxAddToCartUrl', function(){

        event.preventDefault();

        var productId = $(this).attr('data-value'); // to support older extension version
        if(productId == undefined) productId = $(this).attr('data-product'); // nicer to use
        if(productId == undefined) console.warn('data-value Attribute (Product ID) not found in container.')

        var url = '';
        var $currentElem = $(this);

        if($currentElem.hasClass('sxAjaxCompareUrl'))
        {
            url = urls.compareProductUrl;
        }
        else if ($currentElem.hasClass('sxAjaxWishlistUrl'))
        {
            url = urls.wishlistProductUrl;
        }
        else
        {
            url = urls.addToCartUrl;
        }

        $.getJSON(url, { productId : productId },  function(response) {

            if(!response.redirectUrl || typeof response.redirectUrl == 'undefined') return;

            if($currentElem.hasClass('sxExecDataFunction') && $currentElem.attr('data-function'))
            {
                var dataFunction = $currentElem.attr('data-function').replace('sxParam', "'" + response.redirectUrl + "'");

                console.log('class "sxExecDataFunction" found, executing: ' + dataFunction + '...');

                eval(dataFunction + ';');

            } else {
                location.href = response.redirectUrl;
            }

        });
    })


    $(document).on('change', 'select.sxNowJustAjax', sxSetOrderAndFilters);
    $(document).on('click', '.sxNowJustAjax:not(select)', sxSetOrderAndFilters);

    function sxSetOrderAndFilters(event)
    {
        // reset offset
        window.sxOffset = 0;

        event.preventDefault();

        var key, value, option;

        if($(this).prop('tagName') == 'SELECT')
        {
            selectedOption = $(this).find(":selected");

            if(selectedOption.length == 0) return;

            key = selectedOption.attr('data-sxkey');
            value = selectedOption.attr('data-sxvalue');

        } else {
            key = $(this).attr('data-sxkey');
            value = $(this).attr('data-sxvalue');
            option = $(this).attr('data-sxoption');
        }

        /**
         * if just viewMode
         */
        if(key == 'mode' && value)
        {
            changeViewModeTo = value;
            //$.sxStartSearch(); // not needed anymore
        }


        /**
         * set multi_select filters
         */
        if(key && value && option)
        {

            if(sxCurrentQuery[key] && sxCurrentQuery[key][value])
            {
                var newValue = [];
                var alreadySet = false;

                // add or unset if already set
                $.each(sxCurrentQuery[key][value], function(index, element){

                    // rebuilt sxCurrentQuery[key][value] in newValue array

                    if(option != element)
                    {
                        // if its not the current option, add optionId
                        newValue.push(element);
                    } else {

                        // it its current optionId, set alreadySet
                        alreadySet = true;
                    }
                });


                // if it was not already set, set it ...otherwise it was removed (-> not added to the new array)
                if(!alreadySet)
                {
                    newValue.push(option);
                }

                // if the array sxCurrentQuery[key][value] (newValue array) now empty, unset it
                if(newValue.size() == 0)
                {
                    delete(sxCurrentQuery[key][value]);
                } else {
                    sxCurrentQuery[key][value] = newValue;
                }


            } else if (sxCurrentQuery[key]) {

                sxCurrentQuery[key][value] = [option];
                //[value] = [ option ];

            } else {
                sxCurrentQuery[key] = {};
                sxCurrentQuery[key][value] = [ option ];
            }

        }
        /**
         * query settings (ordering, sorting,...)
         */
        else if(key && value)
        {
            sxCurrentQuery[key] = value;
        }

        /**
         * if direction is not already set, set it to DESC (default)
         */

        if(sxCurrentQuery.order && !sxCurrentQuery.direction)
        {
            sxCurrentQuery.direction = 'DESC';
        }

        /**
         *  remove all orders if none
         */
        if(sxCurrentQuery.order === 'none')
        {
            delete sxCurrentQuery.order;
            delete sxCurrentQuery.direction;
        }

        $.sxStartSearch();
    }

    $.sxStartSearch = function(request)
    {
        var requestWasSet = false;

        // add event
        jQuery(document).trigger('semknoxSearchStart', selectors);

        /*
         sxSearchRequest: set in SearchMiniForm.php
         sxCurrentQuery: set in SearchMiniForm.php
         */

        if(!request){

            if(! searchQuery) {
                searchQuery = getSearchQuery();
            }

            var additionalBody = getAdditionalRequestBody();

            request = encodeURIComponent(searchQuery) + additionalBody;
        } else {

            window.sxOffset = 0;
            requestWasSet = true;
        }


        $.post(sxSearchRequest.url , sxSearchRequest.body  + request , function(response)
        {
            // add event
            jQuery(document).trigger('semknoxSearchReady', [selectors, response]);

            // infiniteScroll
            if(window.sxOffset > 0)
            {
                // append to current Listing
                setProductBoxes(response);

                // add event
                jQuery(document).trigger('semknoxSearchFinished', [selectors, response]);

                return;
            } else {

                // scroll to the top
                $("html, body").animate({ scrollTop: 0 }, "fast");
            }


            // if redirect is set in semknox backend, do redirect here
            if(response.redirect) location.href = response.redirect;

            // if filters list template was not loaded but is needed, do native search to cleanup
            if(!$(selectors.filtersList).length && response.filters.length)
            {
                location.href = urls.nativeSearchUrl + getSearchQuery();
                return;
            }

            if(!response.searchResults) return;

            setSearchMessage(response);

            setSemknoxOrderToolbar(response);

            setProductBoxes(response);

            setFilterBoxes(response);

            setContentBoxes(response);

            hideUnusedElements();

            if(!requestWasSet){
                rewriteUrlAndHistory(searchQuery, request);
            }

            // hide pager
            //$(selectors.pager).hide();

            // set semknox tracking cookie
            setTrackingCookie(response);

            // add event
            jQuery(document).trigger('semknoxSearchFinished', [selectors, response]);

            // defined in filters_multiselect.js
            sxReorderFilterLists();

            // defined in filters_multiselect.js
            sxToggleFilters('in', false);

            resetSxCurrentQuery(response);

        });
    };


    /**
     * prepare body and stringify
     *
     * @returns {string}
     */
    function getAdditionalRequestBody()
    {
        var limit = 108;

        if(window.sxLimit < 108){
            limit = window.sxLimit;
        }

        var output = '&limit=' + limit + '&offset=' + window.sxOffset;

        if(sxCurrentQuery.direction || sxCurrentQuery.order){

            var order = {};

            if(!sxCurrentQuery.order || sxCurrentQuery.order == 'name')
            {
                sxCurrentQuery.order = 0;
            }

            if(sxCurrentQuery.direction)
            {
                $(selectors.sortSwitcher).attr('data-sxvalue', sxCurrentQuery.direction);
                $(selectors.sortSwitcher).removeClass('sort-by-switcher--asc');
                $(selectors.sortSwitcher).removeClass('sort-by-switcher--desc');
                $(selectors.sortSwitcher).addClass('sort-by-switcher--' + sxCurrentQuery.direction.toString().toLowerCase());
            }

            order.id = sxCurrentQuery.order;
            order.direction = sxCurrentQuery.direction;

            order = JSON.stringify(order);

            output = output + '&order=' + encodeURIComponent(order);

        }

        if(sxCurrentQuery.filter){

            var filter = sxCurrentQuery.filter;
            var filterSend = [];

            $.each(filter, function(index ,element){

                if(element.minValue){
                    // RANGE filters
                    filterSend.push({ id: index, minValue: element.minValue, maxValue: element.maxValue, unitName: element.unitName });

                } else {
                    // MULTI_SELECT filters
                    filterSend.push({ id: index, values: element });
                }

            });

            filter = JSON.stringify(filterSend);

            output = output + '&filters=' + encodeURIComponent(filter);
        }

        return output;

    }

    function resetSxCurrentQuery(response){

        sxCurrentQuery['filter'] = {};

        $.each(response.filtersSet, function(index ,element){

            if(typeof element.optionsSet == "undefined"){
                // RANGE filters
                sxCurrentQuery.filter[index] = {
                    minValue: element.minValue,
                    maxValue: element.maxValue,
                };
            } else {
                // MULTI_SELECT filters
                sxCurrentQuery.filter[index] = element.optionsSet;

            }

        });
    }


    /***************************************************
     * TEMPLATING...
     ***************************************************
     */

    /**
     * do product output
     * @param response
     */
    function setProductBoxes(response)
    {
        var productContainer;
        var productContainerSelector;

        if($(selectors.productsGrid).length > 0){
            productContainer = $(selectors.productsGrid);
            productContainerSelector = selectors.sxProductBoxgridTemplate;
        } else {
            productContainer = $(selectors.productsList);
            productContainerSelector = selectors.sxProductBoxlistTemplate;
        }

        if(changeViewModeTo && selectors['sxProductBox' + changeViewModeTo + 'Template'])
        {
            productContainerSelector = selectors['sxProductBox' + changeViewModeTo + 'Template'];
            changeViewModeTo = false;
        }

        // if not infinitescroll
        if(window.sxOffset ==  0)
        {
            productContainer.html('');
        }

        if(!response.searchResults) return;


        var productsResponse = response.searchResults;
        var products = [];


        productsResponse.each(function(index){

            // do fancy stuff...
            $.each(index[0].properties,function(key, value){

                key = value.idName.replace(".","");
                index[0][key] = value.value;

            });

            index[0].additional = {};
            $.each(index[0].passOn,function(key, attribute){

                index[0].additional[attribute.key] = attribute.value;
            });

            // add base Url
            index[0].magentoBaseUrl = urls.magentoBaseUrl;

            products.push(index[0]);

        });

        jQuery(document).trigger('semknoxSearchProductsRenderedBefore',[products, response]);

        var list = {
            products : products
        }

        var htmlOutput = $(productContainerSelector).render(list);

        // new product list
        if(window.sxOffset == 0)
        {
            productContainer.replaceWith(function(){

                return $(htmlOutput).hide().fadeIn(500);

            }).promise().done(function(){
                //add event
                jQuery(document).trigger('semknoxSearchProductsRendered',[products, response]);
            });

        }

        // infinite scroll
        else {

            var items = $(htmlOutput).find('li.item').hide();

            items.appendTo(productContainer).promise().done(function () {

                // fade in
                items.fadeIn(500);

                //add event
                jQuery(document).trigger('semknoxSearchProductsRendered', [products, response]);
            });

        }

    };

    /**
     * do Filter output
     * @param response
     */
    function setFilterBoxes(response)
    {
        var filtersList = $(selectors.filtersList);
        filtersList.html('');

        if(!response.filters) return;

        var filtersResponse = response.filters;

        filtersResponse.sort(function(obj1, obj2) {
            return obj1.position - obj2.position;
        });

        var initSlider = [];

        filtersResponse.each(function(index){

            // if Range-Filter, initialize Slider
            if(index.type == 'RANGE'){
                initSlider.push(index);
            }

            // create Css Class
            if(index.idName) {
                index.idNameCss = index.idName.replace('.','');
            }
            else {
                index.idNameCss = '';
            }


            // get active options
            if(typeof response.filtersSet[index.id] != 'undefined' && typeof response.filtersSet[index.id].optionsSet != 'undefined')
            {
                optionsSet = response.filtersSet[index.id].optionsSet;
            } else {
                optionsSet = {};
            }


            index.options.each(function(option){

                // add Css Class
                option.viewNameCss = sxRemoveSpecialChars( option.viewName);

                // add active
                if($.inArray(option.id, optionsSet) >= 0)
                {
                    option.activeCss = ' active ';
                    option.viewNameCss =  option.viewNameCss + ' active';
                } else {
                    option.activeCss = '';
                }
            })

        });

        var template = $.templates(selectors.sxFilterItemTemplate);
        var htmlOutput = template.render(filtersResponse);

        filtersList.html(htmlOutput).promise().done(function(){
            //add event
            jQuery(document).trigger('semknoxSearchFiltersRendered');
        });

        $.sxInitRangeFilter(initSlider, response.filtersSet);

    }

    /**
     * do toolbar (sorting, ordering,...) output
     * @param response
     */
    function setSemknoxOrderToolbar(response)
    {
        var orderToolbar = $(selectors.sxOrderToolbar);
        orderToolbar.html('');

        if(!response.order) return;


        var ordersResponse = [];


        ordersResponse.push({
            id: 'none',
            relation: 'none',
            viewName: 'Relevanz'
        });


        $.each(response.order, function(idx, elem){
            ordersResponse.push(elem);
        });

        var template = $.templates(selectors.sxOrderToolbarTemplate);

        var templateVars = {};
        templateVars.orders = ordersResponse;

        var htmlOutput = template.render(templateVars);

        $(selectors.sxOrderToolbar).replaceWith(htmlOutput);


        var orderSelectHtml = '';
        ordersResponse.each(function(index){

            orderSelectHtml = orderSelectHtml + orderSelectItemHtml.replace(/%orderSelectItem/g, selectors.orderSelectItem).replace(/%viewName/g, index.viewName).replace(/%id/g, index.id);

        });

        $(selectors.orderSelect).html(orderSelectHtml);
        $(selectors.orderSelect).addClass('sxNowJustAjax');
        $(selectors.orderSelect).removeAttr('onchange');

        // set "Relevance" order as active
        $(selectors.sxOrderToolbar + ' a[data-sxvalue=none]').addClass('active');
        if(response.orderSet)
        {
            var orderSet = response.orderSet;
            var order = response.order;

            $.each(orderSet, function(id, direction) {

                var orderItem = $(selectors.sxOrderToolbar + ' a[data-sxvalue=' + id + ']');

                if(orderItem.length)
                {
                    // remove all active classes
                    $(selectors.sxOrderToolbar + ' a').removeClass('active');

                    var directionValue = 'ASC';
                    if(direction == 'ASC') directionValue = 'DESC'

                    orderItem.attr('data-sxvalue', directionValue);
                    orderItem.attr('data-sxkey', 'direction');
                    orderItem.addClass('active');

                    var orderItemViewName = orderItem.html();

                    orderItem.append('<span class="sxSign'+ direction +'">&nbsp;'+ direction +'</span>');
                }

                // set select to correct value
                $.each(order, function(key, item )
                {
                    if(item.id == id) $(selectors.orderSelect).val(item.viewName);
                });

            });

        }
    };

    /**
     * do content output
     * @param response
     */
    function setContentBoxes(response)
    {

        var contentSearchActive = sxContentSearch; // set in SearchMiniForm
        if(!contentSearchActive) return;

        // we want to deal with the existing tabs
        if(!response.contentSearchResults || response.contentSearchResults.length > contentSearchTabsQty){
            // reload page
            location.href = urls.nativeSearchUrl + getSearchQuery();
            return;
        }

        var contentResultTabs = response.contentSearchResults;
        var index = 0;

        contentResultTabs.each(function(value){

            if(value.name == '_') value.name = 'Weitere';

            $('span.content-' + index).html(value.name);

            var list = {
                index: index,
                results : value.results
            }

            var htmlOutput = $(selectors.sxContentListTemplate).render(list);

            $('ol.content-' + index).replaceWith(htmlOutput);

            $('span.content-' + index).parent('li').show();
            $('span.content-' + index).parent('dd').show();

            index++;
        });

        // hide unused tabs
        while(index < contentSearchTabsQty){
            $('span.content-' + index).closest('li').hide();
            $('span.content-' + index).closest('dd').hide();
            index++;
        }

    };


    /**
     * modify search message and string
     * @param response
     */
    function setSearchMessage(response)
    {
        searchQuery = response.interpretedQuery.original;
        $(selectors.sxSearchString).html(searchQuery);
        $(selectors.searchInput).val(searchQuery);

        if(!response.interpretedQuery || !response.interpretedQuery.explanation) return;

        var output = response.interpretedQuery.explanation;

        $(selectors.sxExplanation).html(output);

    };


    /***********************
     * prepare template
     */

    // add .sxNowJustAjax Class
    var addSxNowJustAjaxFor = [selectors.orderSelect, selectors.sortSwitcher, selectors.viewMode]

    addSxNowJustAjaxFor.each(function(elem){

        if($(elem).length > 0)
        {
            $(elem).addClass('sxNowJustAjax');
        }

    })


    // prepare Order Select Template
    if($(selectors.orderSelect).length > 0) {

        $(selectors.orderSelect).attr('onchange','');

        $(selectors.orderSelect + ' ' + selectors.orderSelectItem).each(function(elem, data){

            url = $(data).attr(orderSelectItemValueAttribute);
            $(data).attr('data-sxvalue', getUrlParameter('order', url));
            $(data).attr('data-sxkey', 'order');

            $(data).val('');
        })

    }


    // prepare ViewMode Template
    if($(selectors.viewMode).length > 0)
    {
        $(selectors.viewMode).each(function(elem, data){

            url = $(data).attr('href');

            $(data).attr('data-sxvalue', getUrlParameter('mode', url));
            $(data).attr('data-sxkey', 'mode');

        })
    }
    $(document).on('click', selectors.viewMode, function(event) {

        var inActiveTagName = $(this).prop('tagName');
        var activeTagName =$(selectors.viewModeActive).first().prop('tagName');
        var currentClickedValue = $(this).attr('data-sxvalue');

        // set active to inActive
        var active = $(selectors.viewModeActive);
        var activeValue = active.attr('class');
        active.replaceWith('<'+inActiveTagName+' href="" class="'+activeValue+' sxNowJustAjax" data-sxkey="mode" data-sxvalue="'+activeValue+'">' + active.html() + '</'+inActiveTagName+'>');


        //set clicked to active
        var currentClicked = $(selectors.viewMode + '[data-sxvalue='+ currentClickedValue +']');
        currentClicked.replaceWith('<'+activeTagName+' class="'+ currentClickedValue +'">'+$(this).html()+'</'+activeTagName+'>');
    })


    // prepare Direction Template
    if($(selectors.sortSwitcher).length > 0)
    {
        $(selectors.sortSwitcher).each(function(elem, data){

            url = $(data).attr('href');

            $(data).attr('data-sxvalue', getUrlParameter('dir', url).toUpperCase());
            $(data).attr('data-sxkey', 'direction');
        })
    }
    $(document).on('click', selectors.sortSwitcher, function(event) {

        var currentClickedValue = $(this).attr('data-sxvalue');

        if(currentClickedValue == 'ASC')
        {
            $(selectors.sortSwitcher).attr('data-sxvalue', 'DESC');
            $(selectors.sortSwitcher).removeClass('sort-by-switcher--desc');
            $(selectors.sortSwitcher).addClass('sort-by-switcher--asc');

        } else {
            $(selectors.sortSwitcher).attr('data-sxvalue', 'ASC');
            $(selectors.sortSwitcher).removeClass('sort-by-switcher--asc');
            $(selectors.sortSwitcher).addClass('sort-by-switcher--desc');
        }

    })


    // get Url Param
    function getUrlParameter(sParam, url ) {

        var sCompletePageUrl = decodeURIComponent(url),
            sUrlQuery = sCompletePageUrl.split('?');

        var sPageURL = sUrlQuery[1],
            sURLVariables = sPageURL.split('&'),
            sParameterName,
            i;


        for (i = 0; i < sURLVariables.length; i++) {
            sParameterName = sURLVariables[i].split('=');

            if (sParameterName[0] === sParam) {
                return sParameterName[1] === undefined ? true : sParameterName[1];
            }
        }

        return '';

    };

    // set semknox tracking cookie
    function setTrackingCookie(response){

        if(!response.queryId || typeof response.queryId == 'undefined') return;

        var d = new Date();
        d.setTime(d.getTime() + 31556926);
        var expires = d.toUTCString();

        document.cookie = 'sxLatestQueryId='+response.queryId+';path=/;expires='+expires;   

    }


    /**
     * hide unused elements
     */
    function hideUnusedElements()
    {

        // hide order switch if "relevance"
        if(sxCurrentQuery.order >= 0)
        {
            $(selectors.sortSwitcher).show();
        } else {
            $(selectors.sortSwitcher).hide();
        }


        // hide Pagination if infinitScroll is Active

        // sxInfiniteScroll set in SearchMiniForm.php
        if(sxInfiniteScroll)
        {
            $(selectors.pager).hide();
        }

    }

    hideUnusedElements();


    // if SEO Urls activated, edit pager links
    if(typeof unknowSlugToSearch != 'undefined')
    {
        var pagerLinks = $(selectors.pager + ' .pages a');

        $.each(pagerLinks, function(index, element){

            var linkElem =  $(element);

            var oldUrl = linkElem.attr('href');

            linkElem.attr('href', '?p=' + getUrlParameter('p', oldUrl));

        });
    }


    // check if all images in cache have been "warmed up"
    $(document).on('semknoxSearchProductsRendered', function(event, products, response){

        $('img').on('error', function() {

            var id = $(this).attr('id');
            var src = $(this).attr('src');

            if(src.indexOf('?') >= 0) return false;

            if(typeof id == 'undefined') return;

            var productId = id.replace('product-collection-image-','');

            $.ajax({
                url: urls.sxModulUrl + 'ajax/getproductimages',
                dataType: 'json',
                data: {
                    productIds : productId,
                    width : sxListingImageWidth,
                    height : sxListingImageHeight,
                    type: 'small_image',
                    excluded: 1,
                },
                success: function(responseData){

                    var $img = $('img#'+id);
                    $img.attr('src', src + '?');
                }
            });

        });

    });


    /**
     * edit browser history
     *
     * @param searchQuery
     */
    function rewriteUrlAndHistory(searchQuery, request)
    {
        var url = encodeURIComponent(searchQuery);

        // var unknowSlugToSearch set in seourl.js

        if(typeof unknowSlugToSearch == 'undefined')
        {
            history.pushState(request, '', '?q=' + url);
        } else {
            history.pushState(request, '', url);
        }
    }

    window.addEventListener("popstate", function(e) {

        if(typeof e.state == 'string' && e.state.length){
            $.sxStartSearch(e.state);
        } else {
            location.reload();
        }

    });

    if(typeof history.state == 'string'){
        $.sxStartSearch(history.state);
    }

});