jQuery(document).ready(function($) {

    var iconSrc = 'http://login.semknox.com/images/ivf/';

    $('.sxMULTI_SELECT li a').each(function(){

        var atag = $(this);
        var span = atag.find('span[data-sxkey!=""]').first();

        if(span)
        {
            var sxKey = span.attr('data-sxkey');
            var sxValue = span.attr('data-sxvalue');
            var sxOption = span.attr('data-sxoption');
            var sxFilterOptionClass = sxRemoveSpecialChars(span.text());

            if(span.hasClass('active')) sxFilterOptionClass = sxFilterOptionClass + ' active';

            atag.attr('data-sxkey', sxKey);
            atag.attr('data-sxvalue', sxValue);
            atag.attr('data-sxoption', sxOption);

            atag.addClass('sxNowJustAjax');

            span.removeAttr('data-sxkey');
            span.removeAttr('data-sxvalue');
            span.removeAttr('data-sxoption');

            atag.addClass(sxFilterOptionClass);
            atag.attr('title', sxFilterOptionClass);
        }

    });

    sxToggleFilters('in', false);

    $(document).on('click','.sxToggleOptions', function () {

        if($(this).hasClass('out'))
        {
            sxToggleFilters('out', $(this));
        } else {
            sxToggleFilters('in', $(this));
        }

    })

});


function sxRemoveSpecialChars(value){
    return value.toLowerCase()
        .replace(/ä/g, 'ae')
        .replace(/ö/g, 'oe')
        .replace(/ü/g, 'ue')
        .replace(/ß/g, 'ss')
        .replace(/[^a-z]/g, '');
}


function sxReorderFilterLists(){

    var $lists = jQuery('.sxMULTI_SELECT');

    jQuery.each($lists, function(index, list){

        var $activeElems = jQuery(list).find('li a span.active');

        jQuery.each($activeElems, function(idx, elem){

            var $element = jQuery(elem).parent().parent();
            var $parentList = jQuery(elem).parent().parent().parent();

            $parentList.prepend($element);
        });

    });

}


function sxToggleFilters(direction, elem)
{
    // defined in filteritem.phtml
    if(typeof sxFilterToggleCount == 'undefined') return;
    // defined in filteritem.phtml
    if(typeof sxToggleInWording == 'undefined') sxToggleInWording  =  "<li class='sxToggleOptions in'>weniger anzeigen</li>";
    // defined in filteritem.phtml
    if(typeof sxToggleOutWording == 'undefined') sxToggleOutWording =  "<li class='sxToggleOptions out'>mehr anzeigen</li>";

    var countInit = sxFilterToggleCount;

    var filterGroups = jQuery('.sxMULTI_SELECT');

    var list = false;

    if(elem)
    {
        list = elem.closest('.sxMULTI_SELECT');
        elem.remove();
    }


    // toggle OUT
    if(direction == 'out')
    {
        if(!list) return;

        listOptions = list.find('li');

        listOptions.show();

        listOptions.last().after(sxToggleInWording);

        return;
    }

    // toggle IN
    if(direction == 'in') {

        if(list)
        {
            listOptions = list.find('li[class!=sxToggleOptions]');

            var count = countInit;
            var numOptions = listOptions.length;

            jQuery.each(listOptions, function (i, d) {

                if (count <= 0) {
                    d.hide();
                } else if (count == 1 && numOptions > countInit) {
                    jQuery(d).after(sxToggleOutWording);
                }

                count = count - 1;
            })

            return;
        }

        jQuery.each(filterGroups, function (index, data) {

            var listOptions = jQuery(data).find('li[class!=sxToggleOptions]');
            var count = countInit;
            var numOptions = listOptions.length;

            jQuery.each(listOptions, function (i, d) {

                if (count <= 0) {
                    d.hide();
                } else if (count == 1 && numOptions > countInit) {
                    jQuery(d).after(sxToggleOutWording);
                }

                count = count - 1;
            })
        });
    }
}


    