
jQuery(document).ready(function($) {

    $.sxInitRangeFilter = function(rangeFilters, filtersSet)
    {
        var resultDecimalsCount = {};

        rangeFilters.each(function(index, idx){

            resultDecimalsCount[idx] = (index.step.toString().split('.')[1] || []).length;

            if(!index.minStart || !index.maxStart) {

                if (filtersSet && filtersSet[index.id]) {
                    var rangeSet = filtersSet[index.id];
                    index.minStart = rangeSet.minValue;
                    index.maxStart = rangeSet.maxValue;
                } else {
                    index.minStart = index.min;
                    index.maxStart = index.max;
                }
            }

            var slider = document.getElementById('sxFilter' + index.id);

            var unitName = '';
            if(typeof index.unitName != 'undefined')
            {
                unitName = ' ' + index.unitName;
            }

            var behaviour = "tap";
            if(index.min == index.max) behaviour = "fixed";

            noUiSlider.create(slider, {
                connect: true,
                behaviour: behaviour,
                start: [ index.minStart, index.maxStart ],
                //step: index.step,
                range: {
                    "min": [ index.min ],
                    "max": [ index.max ]
                },
                format: {
                    to: function ( value ) {
                        return value + unitName;
                    },
                    from: function ( value ) {
                        return value.replace(unitName, '');
                    }
                }
            });

            slider.noUiSlider.on('update', function( values, handle ) {

                var value = values[handle];

                value = value.replace(unitName, '').replace(',','.');
                value = parseFloat(value).toFixed(resultDecimalsCount[idx]);
                value = value + unitName;
                value = value.replace('.',',');

                if ( handle ) {
                    $('#sxFilter' + index.id + 'Max').val(value);
                } else {
                    $('#sxFilter' + index.id + 'Min').val(value);
                }
            });

            $('#sxFilter' + index.id + 'Min').on('change', function(){
                slider.noUiSlider.set([this.value, null]);
            });

            $('#sxFilter' + index.id + 'Max').on('change', function(){
                slider.noUiSlider.set([null, this.value]);
            });

            slider.noUiSlider.on('set', function(){

                var add = true;

                var min = $('#sxFilter' + index.id + 'Min').val().replace(unitName, '').replace(',','.');
                var max = $('#sxFilter' + index.id + 'Max').val().replace(unitName, '').replace(',','.');

                min = parseFloat(min).toFixed(resultDecimalsCount[idx]);
                max = parseFloat(max).toFixed(resultDecimalsCount[idx]);

                var sliderMin =  parseFloat(slider.noUiSlider.options.range.min[0]).toFixed(resultDecimalsCount[idx]);
                var sliderMax =  parseFloat(slider.noUiSlider.options.range.max[0]).toFixed(resultDecimalsCount[idx]);

                if(sliderMin == min && sliderMax == max)
                {
                    add = false;
                }

                if(typeof $.sxStartSearch !== 'undefined')
                {
                    // clientSide Search

                    if(!sxCurrentQuery.filter) sxCurrentQuery.filter = {};

                    if(add) {
                        sxCurrentQuery.filter[index.id] = {
                            minValue: min,
                            maxValue: max,
                            unitName: index.unitName
                        };
                    } else {
                        delete sxCurrentQuery.filter[index.id];
                    }

                    // reset offset
                    window.sxOffset = 0;


                    $.sxStartSearch();

                } else {

                    // native Search

                    var url = index.url;

                    if(add) {
                        url = url + '&filter[' + index.id + '][unitName]=' + index.unitName  + '&filter[' + index.id + '][min]=' + min + '&filter[' + index.id + '][max]=' + max;
                    }
                    location.href = url;
                }

            });

        });
    };


    // if ClientSideSearch disabled, look up for range filters
    rangeFiltersFound = $('.sxRANGE');
    rangeFilters = [];

    rangeFiltersFound.each(function(index, data){
        rangeFilters.push($(data).data('sxrange'))
    });

    $.sxInitRangeFilter(rangeFilters)

})