jQuery(document).ready(function ($) {

    if(typeof selectors == 'undefined' || typeof selectors.productsGrid == 'undefined' || typeof selectors.productsList == 'undefined')
    {
        // do nothing if ajaxSearch is disabled
        return;
    }

    var loadNextProducts = true;
    var productsLoaded = 0;
    var productsLeft = 0;
    var productsLoadOnButtonClick = sxInfiniteScrollShowButton;

    var productsCollectionSelector = selectors.productsGrid + ":not(" + selectors.contentList + ")," + selectors.productsList+":not(" + selectors.contentList + ")";

    if(typeof productsReadyEvent == 'undefined') productsReadyEvent  =  'semknoxSearchProductsRendered';

    if(typeof sxMoreProductsButton == 'undefined') sxMoreProductsButton  =  '<button id="sxLoadMore" class="button sxLoadMoreButton">Weitere Produkte laden (%amount%)</button>';
    if(typeof sxMoreProductsButtonSelector == 'undefined') sxMoreProductsButtonSelector  = 'button#sxLoadMore';
    if(typeof sxMoreProductsLoadingInfo == 'undefined') sxMoreProductsLoadingInfo  = '<div id="sxLoadMoreInfo" class="sxLoadMoreInfo">Weitere Produkte werden geladen...</div>';
    if(typeof sxMoreProductsLoadingInfoSelector == 'undefined') sxMoreProductsLoadingInfoSelector  = '#sxLoadMoreInfo';


    if(productsLoadOnButtonClick) {

        $(document).on('click', sxMoreProductsButtonSelector, function(){

            //set new offset
            resetSxOffset();

            $.sxStartSearch();
        });

        //check how many items are rendered and disable button if less than sxLimit
        var countListItems = $(selectors.productsGrid + " > li," + selectors.productsList + " > li").length;

        if(countListItems < window.sxLimit){
            productsLeft = 0;
        } else {
            productsLeft = window.sxLimit;
        }

        placeLoadMoreButton();

    } else {

        $(window).scroll(function () {

            //must be scrolled distance to load more products
            var bottomDistance = $('div.footer').height();//$(document).height() / 2;
            var scrollDistance = $(document).height() - $(window).height() - bottomDistance;

            //load more products while scrollingW
            if ($(window).scrollTop() >= scrollDistance && loadNextProducts) {

                //do not load more Products until its not ready
                loadNextProducts = false;

                //set new offset
                resetSxOffset();

                $(productsCollectionSelector).after(sxMoreProductsLoadingInfo);

                $.sxStartSearch();
            }
        });
    };

    $(document).on(productsReadyEvent, function(event, products, response){

        var resultsAvailable = response.groupedResultsAvailable; //response.resultsAvailable;

        productsLoaded = window.sxOffset + products.length;

        // if needed, defined in external scriptes
        if(typeof productsReadyEventGoOnInfinte == 'undefined' && productsLoaded < resultsAvailable){
            loadNextProducts = true;
        }

        productsLeft = resultsAvailable - productsLoaded;

        if(productsLoadOnButtonClick) {
            placeLoadMoreButton();
        }

        $(sxMoreProductsLoadingInfoSelector).remove();
    });


    // if needed, defined in external scriptes
    if(typeof productsReadyEventGoOnInfinte != 'undefined'){

        $(document).on(productsReadyEventGoOnInfinte, function(event){
            //allowed to load more products now
            loadNextProducts = true;
        })
    }

    function resetSxOffset(){

        if(window.sxOffset == 0) {
            //count current shown products
            var $productItemsObject = $(selectors.productsGrid + " li.item," + selectors.productsList + " li.item");

            if (typeof $productItemsObject !== 'undefined') {
                window.sxOffset = $(selectors.productsGrid + " li.item," + selectors.productsList + " li.item").length;
                return;
            }
        }
        // else return calculated
        window.sxOffset = window.sxOffset + window.sxLimit;
        return

    };

    function placeLoadMoreButton(){

        //remove all old buttons
        $(sxMoreProductsButtonSelector).remove();

        //get amount of products left to display within button
        var amount = productsLeft;

        if(amount > window.sxLimit){
            amount = window.sxLimit
        } else if (amount <= 0) {
            return false;
        }

        //replace amount with variable
        var html = sxMoreProductsButton.replace('%amount%', amount);
        $(productsCollectionSelector).after(html);
    };

});